############################################################################
# Copyright (C) 2004 Eric Seigne
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : multiplications.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 01/11/2004
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version    $Id: multiplications.tcl,v 1.4 2004/12/23 12:52:32 david Exp $
# @author     David Lucardi
# @project
# @copyright  Eric Seigne
#
#
#########################################################################
#!/bin/sh
#multiplications.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

global plateforme user listdata arg1 listgen indfich
set plateforme $tcl_platform(platform)
set ident $tcl_platform(user)

source fonts.tcl
source path.tcl
source eval.tcl
source msg.tcl

inithome
initlog $plateforme $ident
changehome


set c .frame.c
########################################
set arg1 [lindex $argv 0]
#set arg1 0
#########################################"

#interface
. configure -background #ffff80 
frame .frame -width 640 -height 420 -background #ffff80
pack .frame -side top -fill both -expand yes
wm geometry . +0+0
canvas $c -width 640 -height 400 -background #ffff80 -highlightbackground #ffff80
pack $c

#ouverture du fichier additions.conf
set f [open [file join $Home reglages multiplications.conf] "r"]
set listgen [gets $f]
close $f

image create photo bien -file [file join sysdata pbien.gif] 
image create photo pass -file [file join sysdata ppass.gif]
image create photo mal -file [file join sysdata pmal.gif]
image create photo neutre -file [file join sysdata pneutre.gif]
image create photo ok1 -file [file join sysdata ok1.gif]
image create photo ok0 -file [file join sysdata ok0.gif]

set indfich 0


#procdure principale
proc place {c} {
global listdata arg1 listgen user basedir progaide mode data indfich total sysFont nbcol nbrow curcol currow plateforme taillerect org0 org1 donnee resultf decim erreurscalcul1 erreurscalcul2 erreurvirg erreursplacement partdec1 partdec2
#recup de l'activit dans listdata
set listdata [lindex $listgen $arg1]
wm title . "[mc {Multiplications}] [lindex [lindex $listdata 0] 0]"
catch {destroy .bframe}
frame .bframe -background #ffff80
pack .bframe -side bottom

set erreurscalcul1 0
set erreursplacement 0
set erreurvirg 0
set erreurscalcul2 0
set mode [lindex $listdata 1]
set data [lindex $listdata 2]
set donnee [lindex $data $indfich]

label .bframe.consigne -background #ffff80 -text [mc {Pose l'operation et appuie sur la touche entree}]
grid .bframe.consigne -column 0 -padx 10 -row 0
#button .bframe.ok -background #ffff80 -image ok1 -command "verifplace $c"
#grid .bframe.ok -column 1 -padx 10 -row 0
bind $c <Return> "verifplace $c"

set total [llength $data]
$c delete all

set decim 0
set tmp 0
set partdec1 0
set partdec2 0


for {set i 0} {$i < [llength $donnee]} {incr i 1} {
set l$i [string length [lindex $donnee $i]]
if {[expr \$l$i] > $tmp} {set tmp [expr \$l$i]}
if {[string first , [lindex $donnee $i]] != -1} {
set decim 1
set partdec[expr \$i +1] [expr [string length [lindex $donnee $i]] - [string first , [lindex $donnee $i]] -1]
}
}

set minv 0
if {[string first , [lindex $donnee 1]] != -1} {set minv 1}

set nbcol [expr [string length [lindex $donnee 0]] + [string length [lindex $donnee 1]] -1 - $minv]
#$c create text 100 100 -text "[string length [lindex $donnee 0]] [string length [lindex $donnee 1]] $minv"
set tmp [lindex $donnee 0]
for {set i 1} {$i < [llength $donnee]} {incr i 1} {
set tmp "$tmp * [lindex $donnee $i]"
#if {$nbcol < [string length [lindex $donnee $i]]} {set nbcol [string length [lindex $donnee $i]]}
}
#incr nbcol
if {$nbcol < [expr [string length [expr [string map {, .} $tmp]]] - $decim]} {set nbcol [expr [string length [expr [string map {, .} $tmp]]] - $decim]}
#$c create text 100 100 -text "[expr [string length [expr [string map {, .} $tmp]]]]"

set nbrow [expr [llength $donnee] ]
set currow 0
set curcol $nbcol
set taillerect 25
set org0 [expr 320 - int((($nbcol +1)*$taillerect)/2)]
set org1 50

$c create text [expr 320] [expr 20] -text $tmp -font $sysFont(t) -tags operation
#set resultat [expr [string map {, .} [lindex $donnee 0]] + [string map {, .} [lindex $donnee 1]]]
set resultf [expr [string map {, .} $tmp]]

for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    $c create rect [expr $org0 + $i*$taillerect] [expr $org1 + $j*$taillerect ]  [expr $org0 + ($i+1)*$taillerect]  [expr $org1 + ($j+1)*$taillerect]  -width 2 -fill gray -tags rectcol[expr \$i]row[expr \$j]
    $c create text [expr $org0 + $i*$taillerect + int($taillerect/2)] [expr $org1 + $j*$taillerect + int($taillerect/2)] -tags textcol[expr \$i]row[expr \$j] -font $sysFont(t)

  }
}
for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow -1]} {incr j 1} {
    $c itemconf  textcol[expr \$i]row[expr \$j] -text .
    $c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> "changefocus $c"
    $c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> "changefocus $c"

  }
}

bind $c <KeyPress> "changenum $c %K"
bind $c <Right> "changecell $c right 1 [expr $nbrow -1] 1 $nbcol"
bind $c <Up> "changecell $c up 0 [expr $nbrow -1] 1 $nbcol"
bind $c <Left> "changecell $c left 1 [expr $nbrow -1] 1 $nbcol"
bind $c <Down> "changecell $c down 0 [expr $nbrow -1] 1 $nbcol"

if { $plateforme == "unix" }  {
bind $c <KP_Right> "changecell $c right 1 [expr $nbrow -1] 1 $nbcol"
bind $c <KP_Left> "changecell $c left 1 [expr $nbrow -1] 1 $nbcol"
bind $c "changecell $c down 1 [expr $nbrow -1] 1 $nbcol"
bind $c  <KP_Up> "changecell $c up 1 [expr $nbrow -1] 1 $nbcol"
}

focus -force .frame.c
for {set i 1} {$i < [expr $nbrow]} {incr i 1} {
$c itemconf textcol0row$i -text X
}
$c create line [expr $org0] [expr $org1 + $nbrow*$taillerect ]  [expr $org0 + [expr $nbcol +1]*$taillerect]  [expr $org1 + $nbrow*$taillerect]  -width 4 -fill red -tags line
$c itemconf rectcol[expr \$nbcol]row0 -fill white
	
}


#appel de la procdure principale
place $c



proc changefocus {c} {
global nbcol nbrow curcol currow taillerect org0 org1
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    $c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
  }
}
set coord [$c coords current]
set xc [expr int(([lindex $coord 0]- $org0)/$taillerect)]
set yc [expr int(([lindex $coord 1]-$org1)/$taillerect)]
$c itemconf rectcol[expr \$xc]row[expr \$yc] -fill white
set curcol $xc
set currow $yc
}

proc changecell {c where rmin rmax cmin cmax} {
global nbcol nbrow curcol currow taillerect
   switch $where {
        right { 
		  set tmp [expr $curcol +1]
		    if {$tmp <= $cmax} {
			set curcol $tmp
		    }
		  }
	left { 
		  set tmp [expr $curcol -1]
		    if {$tmp >= $cmin} {
			set curcol $tmp
		    }
		  }
	down { 
		  set tmp [expr $currow +1]
		    if {$tmp <= $rmax} {
			set currow $tmp
		    }
		  }
	up { 
		  set tmp [expr $currow -1]
		    if {$tmp >= $rmin} {
			set currow $tmp
		    }
		  }

  }
for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow -1]} {incr j 1} {
    $c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
  }
}
$c itemconf rectcol[expr \$curcol]row[expr \$currow] -fill white

}

proc changenum {c key} {
global curcol currow
focus -force .frame.c

switch $key {
BackSpace - Delete {$c itemconf textcol[expr \$curcol]row[expr \$currow] -text .}
0 - 1 - 2 - 3 - 4 - 5 - 6 - 7 - 8 - 9  {$c itemconf textcol[expr \$curcol]row[expr \$currow] -text $key}
comma {$c itemconf textcol[expr \$curcol]row[expr \$currow] -text ,}
}
}



proc verifplace {c} {
global nbcol donnee nbrow currow curcol sysFont activecol decim erreursplacement retenue ancretenue curligne resultat decalage actcol
set retenue 0
set ancretenue 0
set resultat 0
set decalage 0
set actcol $nbcol
set curligne $nbcol

	for {set j 0} {$j < [expr $nbrow]} {incr j 1} {
	set nomb ""
	set saisie ""
		for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
		set saisie [$c itemcget textcol[expr \$i]row[expr \$j] -text]
		set nomb $nomb$saisie
		}

	set tmp [string trim $nomb .]
		if {[string first . $tmp] != -1} {
# pas de . au milieu du nombre
		set answer [tk_messageBox -message "[mc {Erreur au nombre}] [expr $j +1]" -type ok]
		incr erreursplacement 
		return
		}

		if {[string equal [string trimleft [lindex $donnee [expr $j]] 0] [string trimleft $nomb .]] != 1} {
		incr erreursplacement
		set answer [tk_messageBox -message "[mc {Erreur au nombre}] [expr $j +1]" -type ok] 
		return
	} 
}

.bframe.consigne configure -text [mc {Effectue et valide en appuyant sur entree(Pense aux retenues!)}]
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    $c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
  }
}
set curcol $nbcol
set activecol $nbcol
set currow $nbrow
$c itemconf rectcol[expr \$curcol]row[expr \$currow] -fill white
for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow -1]} {incr j 1} {
    $c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
    $c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
  }
}

catch {destroy .bframe.ok}
bind $c <Return> "verifope $c"

bind $c <Right> ""
bind $c <Up> ""
bind $c <Left> ""
bind $c <Down> ""


$c bind rectcol[expr \$curcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
$c bind textcol[expr \$curcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
$c itemconf textcol[expr \$curcol]row0 -fill blue
$c itemconf textcol[expr \$curligne]row1 -fill blue
set tmp1 0
set tmp2 0
if {[$c itemcget textcol[expr \$curcol]row0 -text] != "" && [$c itemcget textcol[expr \$curcol]row0 -text] != ","} {
set tmp1 [string map {. 0} [$c itemcget textcol[expr \$curcol]row0 -text]]
}
if {[$c itemcget textcol[expr \$curligne]row1 -text] != "" && [$c itemcget textcol[expr \$curligne]row1 -text] != ","} {
set tmp2 [string map {. 0} [$c itemcget textcol[expr \$curligne]row1 -text]]
}
set tmp [expr $tmp1 * $tmp2]
if {[string length $tmp] > 1} {
set retenue [string index $tmp 0]
set resultat [string index $tmp 1]
} else {
set resultat $tmp
}


for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
    $c itemconf  textcol[expr \$i]row[expr $nbrow] -text .
}
$c create text 50 20 -text [mc {Retenue :}] -font sysFont(t) -tag efface
catch [entry $c.retenue -font $sysFont(t) -width 2]
$c create window 100 20 -window $c.retenue -tag efface
$c.retenue insert end "0"
$c create text 64 40 -text "(Ancienne retenue : $ancretenue)" -tag "efface ancret"
focus $c
bind $c.retenue <KeyRelease> "verifret $c %A"
bind $c.retenue <1> "$c.retenue delete 0 end"
}

proc verifret {c key} {
switch $key {
0 - 1 - 2 - 3 - 4 - 5 - 6 - 7 - 8 - 9  {}
default {
$c.retenue delete 0 end
$c.retenue insert end "0"}
}
focus $c
}

proc verifope {c} {
global curcol currow nbcol nbrow activecol indfich resultf total decim listdata erreurscalcul1 erreursplacement user curligne retenue resultat taillerect org0 org1 sysFont decalage actcol ancretenue
set result 0
set averif 0
$c itemconf ancret -text "(ancienne retenue : $ancretenue)"

#catch [$c delete -withtag essai]
#$c create text 100 100 -text $decalage -tags essai

if {[$c itemcget textcol[expr \$actcol]row[expr \$currow] -text] != "" && [$c itemcget textcol[expr \$actcol]row[expr \$currow] -text] != "," && [$c itemcget textcol[expr \$actcol]row[expr \$currow] -text] != "."} {
set result [$c itemcget textcol[expr \$actcol]row[expr \$currow] -text]
} else {
if {$decalage == 0 } {
incr erreurscalcul1
set answer [tk_messageBox -message [mc {Erreur de calcul}] -type ok] 
return
}
} 

set tmpresult $result
if {[$c.retenue get] != ""} {set result [$c.retenue get]$result}

set result1 [string trimleft $retenue$resultat 0]
if {$result1 == ""} {set result1 0}
set result [string trimleft $result 0]
if {$result == ""} {set result 0}

#$c create text 100 100 -text "[expr $result1] [expr $result]" -tags essai
if {$decalage ==0} {
	if {[expr $result1] != [expr $result]} {
		incr erreurscalcul1
		set answer [tk_messageBox -message [mc {Erreur de calcul}] -type ok] 
		return
	} 
} else {
	if {[expr $tmpresult] != "0" && $tmpresult != "." && $tmpresult != ""} {
		incr erreurscalcul1
		set answer [tk_messageBox -message [mc {Erreur : dcalage des lignes}] -type ok] 
		return
	} else {
		for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
		for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
		$c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
		$c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
		$c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
		}
		}
	}
#$c create text 100 100 -text "traitement decalage" -tags essai
set actcol [expr $actcol -1]
set decalage [expr $decalage -1]

$c itemconf rectcol[expr \$actcol]row[expr \$currow] -fill white
$c bind rectcol[expr \$actcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
$c bind textcol[expr \$actcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
set curcol $actcol
return
}


set activecol [expr $activecol -1]
set actcol [expr $actcol -1]

if {[$c itemcget textcol[expr \$activecol]row0 -text] == ","} {set activecol [expr $activecol -1]}
	if {([$c itemcget textcol[expr \$activecol]row0 -text] == "" || [$c itemcget textcol[expr \$activecol]row0 -text] == ".") && $retenue == "0"} {
	set activecol $nbcol
	set actcol $nbcol
	set curligne [expr $curligne -1]
	if {[$c itemcget textcol[expr \$curligne]row1 -text] == ","} {set curligne [expr $curligne -1]}
		if {[$c itemcget textcol[expr \$curligne]row1 -text] == "" || [$c itemcget textcol[expr \$curligne]row1 -text] == "." || [$c itemcget textcol[expr \$curligne]row1 -text] == "X"} {
		# c'est fini
		for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  		for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    		$c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
		$c itemconf  textcol[expr \$i]row[expr \$j] -fill black
  		}
		}
		
		if {[expr $nbrow - 2] == "0"} {
		
		bind $c <KeyPress> ""
		$c delete efface
#####################################################################################"
		bind $c <Return> ""
		if {$decim == 1} {
		geredecim $c
		return
		}
		geresuite $c
		return
		}
		set answer [tk_messageBox -message [mc {Maintenant l'addition!}] -type ok]
		$c delete efface
			incr nbrow
			for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
    			$c create rect [expr $org0 + $i*$taillerect] [expr $org1 + $nbrow*$taillerect ]  [expr $org0 + ($i+1)*$taillerect]  [expr $org1 + ($nbrow+1)*$taillerect]  -width 2 -fill gray -tags rectcol[expr \$i]row[expr \$nbrow]
    			$c create text [expr $org0 + $i*$taillerect + int($taillerect/2)] [expr $org1 + $nbrow*$taillerect + int($taillerect/2)] -tags textcol[expr \$i]row[expr \$nbrow] -font $sysFont(t) -text .
  			}
##############################"""""
			for {set j [expr $nbrow -1]} {$j >= 2} {incr j -1} {
			for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
			$c itemconf textcol[expr \$i]row[expr \$j +1] -text [$c itemcget textcol[expr \$i]row[expr \$j] -text]
			}
			}
			for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
			$c itemconf textcol[expr \$i]row2 -text .
			}

####################################
			for {set i 4} {$i <= [expr $nbrow]} {incr i 1} {
			$c itemconf textcol0row[expr \$i] -text +
			}
 			incr nbrow
			for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
    			$c create rect [expr $org0 + $i*$taillerect] [expr $org1 + $nbrow*$taillerect ]  [expr $org0 + ($i+1)*$taillerect]  [expr $org1 + ($nbrow+1)*$taillerect]  -width 2 -fill gray -tags rectcol[expr \$i]row[expr \$nbrow]
    			$c create text [expr $org0 + $i*$taillerect + int($taillerect/2)] [expr $org1 + $nbrow*$taillerect + int($taillerect/2)] -tags textcol[expr \$i]row[expr \$nbrow] -font $sysFont(t) -text .
  			}
			$c create line [expr $org0] [expr $org1 + $nbrow*$taillerect ]  [expr $org0 + [expr $nbcol +1]*$taillerect]  [expr $org1 + $nbrow*$taillerect]  -width 4 -fill red -tags line
			$c itemconf rectcol[expr \$nbcol]row[expr \$nbrow] -fill white
			for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  			for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    			$c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
    			$c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
  			}
			}
			set currow $nbrow
			set curcol $nbcol
			set activecol $nbcol
			#############################################################################""""
			$c bind rectcol[expr \$curcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
			$c bind textcol[expr \$curcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
			$c bind rectcol[expr \$curcol -1]row2 <ButtonRelease-1> "changefocus $c"
			$c bind textcol[expr \$curcol -1]row2 <ButtonRelease-1> "changefocus $c"
			for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
    			$c itemconf  textcol[expr \$i]row2 -fill blue -font $sysFont(s)
			}

######################################################################
			bind $c <Return> "verifope2 $c"

################################################################################################"
		return
		} else {
		set nbrow [expr $nbrow +1]
		set currow $nbrow
		set retenue 0
		set ancretenue 0
		set decalage [expr $nbrow - 2]
			for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
    			$c create rect [expr $org0 + $i*$taillerect] [expr $org1 + $nbrow*$taillerect ]  [expr $org0 + ($i+1)*$taillerect]  [expr $org1 + ($nbrow+1)*$taillerect]  -width 2 -fill gray -tags rectcol[expr \$i]row[expr \$nbrow]
    			$c create text [expr $org0 + $i*$taillerect + int($taillerect/2)] [expr $org1 + $nbrow*$taillerect + int($taillerect/2)] -tags textcol[expr \$i]row[expr \$nbrow] -font $sysFont(t) -text .
  			}
		
		}
	}
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
$c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
$c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
$c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
$c itemconf textcol[expr \$i]row[expr \$j] -fill black
}
}
#$c create text 100 100 -text "traitement normal decalage $decalage curligne $curligne nbcol $nbcol nbrow $nbrow" -tags essai

$c itemconf rectcol[expr \$actcol]row[expr \$currow] -fill white
$c bind rectcol[expr \$actcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
$c bind textcol[expr \$actcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
set curcol $actcol
set tmp1 0
set tmp2 0
#############################"curcole

if {[$c itemcget textcol[expr \$activecol]row0 -text] != "" && [$c itemcget textcol[expr \$activecol]row0 -text] != ","} {
set tmp1 [string map {. 0} [$c itemcget textcol[expr \$activecol]row0 -text]]
$c itemconf textcol[expr \$activecol]row0 -fill blue
}
if {[$c itemcget textcol[expr \$curligne]row1 -text] != "" && [$c itemcget textcol[expr \$curligne]row1 -text] != ","} {
set tmp2 [string map {. 0} [$c itemcget textcol[expr \$curligne]row1 -text]]
$c itemconf textcol[expr \$curligne]row1 -fill blue
}
set tmp [expr ($tmp1 * $tmp2) + $retenue]
set ancretenue $retenue
set retenue 0
if {[string length $tmp] > 1} {
set retenue [string index $tmp 0]
set resultat [string index $tmp 1]
} else {
set resultat $tmp
}

}

proc verifope2 {c} {
global curcol currow nbcol nbrow activecol indfich resultf total partint decim listdata erreurscalcul2 erreursplacement user
set result 0
set averif 0
set pas 1
for {set i 2} {$i < [expr $nbrow]} {incr i 1} {
if {[$c itemcget textcol[expr \$activecol]row$i -text] != "" && [$c itemcget textcol[expr \$activecol]row$i -text] != "," && [$c itemcget textcol[expr \$activecol]row$i -text] != "+"} {
set result [expr $result + [string map {. 0} [$c itemcget textcol[expr \$activecol]row$i -text]]]
}
}

# si nombre entier
set averif [string map {. 0} [$c itemcget textcol[expr \$activecol - $pas]row2 -text]][string map {. 0} [$c itemcget textcol[expr \$activecol]row[expr \$nbrow] -text]]


###### eviter le pb de conversion implicite en octale
set averif [string trimleft $averif 0]
if {$averif == ""} {set averif 0}
set result [string trimleft $result 0]
if {$result == ""} {set result 0}

	if {[expr $averif] != [expr $result]} {
	incr erreurscalcul2
	set answer [tk_messageBox -message [mc {Erreur de calcul}] -type ok] 
	return
	} else {
	set activecol [expr $activecol -1]
	for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  	for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    	$c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
	$c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
	$c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
  	}
	}

		if {$activecol < 0} {
		bind $c <Return> ""
		if {$decim == 1} {
		geredecim $c
		return
		}

		geresuite $c
		} else {
		$c itemconf rectcol[expr \$activecol]row[expr \$nbrow] -fill white
		$c bind rectcol[expr \$activecol]row[expr \$nbrow] <ButtonRelease-1> "changefocus $c"
		$c bind textcol[expr \$activecol]row[expr \$nbrow] <ButtonRelease-1> "changefocus $c"
		$c bind rectcol[expr \$activecol -1]row2 <ButtonRelease-1> "changefocus $c"
		$c bind textcol[expr \$activecol -1]row2 <ButtonRelease-1> "changefocus $c"
		set currow $nbrow
		set curcol $activecol
		}
	}

}

proc geredecim {c} {
global nbcol nbrow
set answer [tk_messageBox -message "Placement de la virgule" -type ok]
.bframe.consigne configure -text [mc {Clique sur un chiffre du resultat pour placer la virgule et valide avec la touche entree.}]
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
$c bind rectcol[expr \$i]row[expr \$nbrow] <ButtonRelease-1> "placevirg $c"
$c bind textcol[expr \$i]row[expr \$nbrow] <ButtonRelease-1> "placevirg $c"
}
bind $c <Return> "verifvirg $c"
}

proc placevirg {c} {
global nbrow nbcol currow curcol taillerect org0 org1
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
$c itemconf textcol[expr \$i]row[expr \$nbrow] -text [string index [$c itemcget textcol[expr \$i]row[expr \$nbrow] -text] 0]
}
set coord [$c coords current]
set xc [expr int(([lindex $coord 0]- $org0)/$taillerect)]
set yc [expr int(([lindex $coord 1]-$org1)/$taillerect)]
$c itemconf textcol[expr \$xc]row[expr \$yc] -text "[$c itemcget textcol[expr \$xc]row[expr \$yc] -text],"
}

proc verifvirg {c} {
global partdec1 partdec2 erreurvirg nbrow nbcol
set virg [expr $nbcol - ($partdec1 + $partdec2)]
if {[string first , [$c itemcget textcol[expr \$virg]row[expr \$nbrow] -text]] != -1} {
geresuite $c
return
} else {
set answer [tk_messageBox -message [mc {Erreur de placement de la virgule}] -type ok]
incr erreurvirg
}
}

proc geresuite {c} {
global listdata indfich total resultf user erreursplacement erreurscalcul1 erreurvirg erreurscalcul2
$c itemconf operation -text "[$c itemcget operation -text] = [string map {. ,} $resultf]"
set str "\173[mc {Operation effectuee : }] [$c itemcget operation -text]\175"
enregistreeval Multiplications [lindex $listdata 0] $str $user
appendeval "\173[mc {Erreur(s) de placement :}]$erreursplacement\175\040\173[mc {Erreur(s) de calcul (multiplication) :}]$erreurscalcul1\175\040\173[mc {Erreur(s) de calcul (addition) :}]$erreurscalcul2\175\040\173[mc {Erreur(s) de virgule :}]$erreurvirg\175" $user
set answer [tk_messageBox -message "[mc {Operation terminee}] \n [mc {Erreur(s) de placement :}]$erreursplacement \n [mc {Erreur(s) de calcul (multiplication) :}]$erreurscalcul1 \n [mc {Erreur(s) de calcul (addition) :}]$erreurscalcul2 \n [mc {Erreur(s) de virgule :}]$erreurvirg" -type ok]
incr indfich
	if {$indfich < $total} {
	.bframe.consigne configure -text [mc {Appuie sur le bouton pour continuer}]
	button .bframe.ok -background #ffff80 -image ok1 -command "place $c"
	grid .bframe.ok -column 1 -padx 10 -row 0
	return
	} else {
	.bframe.consigne configure -text [mc {C'est fini!}]
	}

}
