#!/bin/sh
#operations.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

############################################################################
# Copyright (C) 2002 Eric Seigne
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : operations.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 01/11/2004
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version    $Id: operations.tcl,v 1.4 2006/01/21 13:31:07 david Exp $
# @author     David Lucardi
# @project
# @copyright  Eric Seigne
#
#
#########################################################################


set plateforme $tcl_platform(platform)
set ident $tcl_platform(user)

source fonts.tcl
source path.tcl
source msg.tcl


init $plateforme
inithome
initlog $plateforme $ident
changehome


#####################################################################"
proc majmenu {} {
global Home
variable soustret
catch {.menu.action.m1 delete 0 end}
catch {.menu.action.m2 delete 0 end}
catch {.menu.action.m3 delete 0 end}
catch {.menu.action.m4 delete 0 end}
catch {.menu.action.m5 delete 0 end}
catch {.menu.action.m6 delete 0 end}
catch {.menu.action.m7 delete 0 end}
if {$soustret==0} {
set soust soustractions2.tcl
} else {
set soust soustractions.tcl
}
set f [open [file join $Home reglages additions.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m1 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli additions.tcl $k"
	}
set f [open [file join $Home reglages soustractions.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m2 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli $soust $k"
	}

set f [open [file join $Home reglages multiplications.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m3 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli multiplications.tcl $k"
	}


}


#######################################################################"

proc interface {} {
global iwish basedir Home plateforme progaide sysFont abuledu prof baseHome
variable soustret

set f [open [file join $Home reglages repert.conf] "r"]
set listdata [gets $f]
close $f
set repert $listdata


set f [open [file join $Home reglages regsoust.conf] "r"]
set listdata [gets $f]
close $f
set soustret $listdata

if {$soustret==0} {
set soust soustractions2.tcl
} else {
set soust soustractions.tcl
}


. configure -background #ffff80
catch {
destroy .menu
destroy .wleft
destroy .wcenter
destroy .wright
}
menu .menu

# Creation du menu Fichier
menu .menu.fichier -tearoff 0
.menu add cascade -label [mc {Fichier}] -menu .menu.fichier
if {($abuledu == 0) || ($repert==0) || ($prof==1)} {
.menu.fichier add cascade -label [mc {Editeur}] -menu .menu.fichier.editeur
} else {
.menu.fichier add cascade -label [mc {Editeur}] -menu .menu.fichier.editeur -state disabled
}
menu .menu.fichier.editeur -tearoff 0

.menu.fichier.editeur add command -label [mc {Additions}] -command "exec $iwish editadditions.tcl &"
.menu.fichier.editeur add command -label [mc {Soustractions}] -command "exec $iwish editsoustractions.tcl &"
.menu.fichier.editeur add command -label [mc {Multiplications}] -command "exec $iwish editmultiplications.tcl &"
#.menu.fichier.editeur add command -label [mc {Barques}] -command "exec $iwish editbarques.tcl barque &"


.menu.fichier add command -label [mc {Bilans}] -command "exec $iwish bilan.tcl &"
.menu.fichier add sep
.menu.fichier add command -label [mc {Quitter}] -command exit

menu .menu.action -tearoff 0
.menu add cascade -label [mc {Activites}] -menu .menu.action
menu .menu.action.m1 -tearoff 0
.menu.action add cascade -label [mc {Additions}] -menu .menu.action.m1

menu .menu.action.m2 -tearoff 0 
.menu.action add cascade -label [mc {Soustractions}] -menu .menu.action.m2 
menu .menu.action.m3 -tearoff 0 
.menu.action add cascade -label [mc {Multiplications}] -menu .menu.action.m3 
menu .menu.action.m4 -tearoff 0 
#.menu.action add cascade -label [mc {Constellation}] -menu .menu.action.m4 
#menu .menu.action.m5 -tearoff 0 

menu .menu.options -tearoff 0
.menu add cascade -label [mc {Reglages}] -menu .menu.options

################################################################"
menu .menu.options.regsoust -tearoff 0 
.menu.options add cascade -label "[mc {Soustraction}]" -menu .menu.options.regsoust
.menu.options.regsoust add radio -label "[mc {Retenue classique}]" -variable soustret -value 1 -command "setsoustret 1"
.menu.options.regsoust add radio -label "[mc {Retenue anglo-saxonne}]" -variable soustret -value 0 -command "setsoustret 0"

############################################################""
set ext .msg
menu .menu.options.lang -tearoff 0 
.menu.options add cascade -label "[mc {Langue}]" -menu .menu.options.lang

foreach i [glob [file join  $basedir msgs *$ext]] {
set langue [string map {.msg ""} [file tail $i]]
.menu.options.lang add radio -label $langue -variable langue -command "setlang $langue"
}


menu .menu.options.dossier -tearoff 0 
.menu.options add cascade -label [mc {Dossier de travail}] -menu .menu.options.dossier
.menu.options.dossier add radio -label [mc {Individuel}] -variable repert -value 0 -command "changehomeupdate"
.menu.options.dossier add radio -label [mc {Commun}] -variable repert -value 1 -command "changehomeupdate"


changehome

if {$plateforme == "windows"} {
.menu add command -label [mc {Utilisateur}] -command "setwindowsusername"
}

menu .menu.aide -tearoff 0
.menu add cascade -label [mc {?}] -menu .menu.aide

	if {[file exists [file join $baseHome reglages lang.conf]] == 1} {
	set f [open [file join $baseHome reglages lang.conf] "r"]
  	gets $f lang
  	close $f
	set fich "_index.htm"
	set fich $lang$fich
	set fichier [file join [pwd] aide $fich]
	} else {
	set fichier [file join [pwd] aide fr_index.htm]
	}
if {[file exists $fichier] != 1} {
set fichier [file join [pwd] aide fr_index.htm]
}

.menu.aide add command -label [mc {Aide}] -command "exec $progaide file:$fichier &"
.menu.aide add command -label [mc {A propos ...}] -command "source apropos.tcl"

. configure -menu .menu

. configure -background blue
frame .wleft -background blue -height 300 -width 200
pack .wleft -side left


label .wleft.labA1 -text [mc {Additions}] -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify left -foreground orange
pack .wleft.labA1 -side top -anchor w
bind .wleft.labA1 <1> "lanceappli additions.tcl 0"
bind .wleft.labA1 <Any-Enter> ".wleft.labA1 configure -foreground yellow"
bind .wleft.labA1 <Any-Leave> ".wleft.labA1 configure -foreground orange"

label .wleft.labA2 -text [mc {Soustractions}] -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify left -foreground orange
pack .wleft.labA2 -side top -anchor w
bind .wleft.labA2 <1> "lanceappli $soust 0"
bind .wleft.labA2 <Any-Enter> ".wleft.labA2 configure -foreground yellow"
bind .wleft.labA2 <Any-Leave> ".wleft.labA2 configure -foreground orange"



frame .wcenter -background blue -height 300 -width 200
pack .wcenter -side left

frame .wright -background blue -height 300 -width 200
pack .wright -side left
label .wright.labA2 -text [mc {Multiplications}] -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify right -foreground orange
pack .wright.labA2 -side top -anchor e
bind .wright.labA2 <1> "lanceappli multiplications.tcl 0"
bind .wright.labA2 <Any-Enter> ".wright.labA2 configure -foreground yellow"
bind .wright.labA2 <Any-Leave> ".wright.labA2 configure -foreground orange"



set myimage [image create photo -file sysdata/background.gif]
label .wcenter.imagedisplayer -image $myimage -background blue
pack .wcenter.imagedisplayer -side top

majmenu

}
proc bientot {} {
set answer [tk_messageBox -message [mc {C'est pour bientt!}] -type ok]
}
interface

############
# Bindings #
############
bind . <Control-q> {exit}

bind . <FocusIn> {majmenu}



proc lanceappli {appli niveau} {
global iwish
set appli [file join $appli]
#appli.tcl index_dans_le_scnario
exec $iwish $appli $niveau &
}



proc changehomeupdate {} {
changehome
interface
majmenu
}

proc setsoustret {what} {
global baseHome
set f [open [file join $baseHome reglages regsoust.conf] "w"]
puts $f $what
close $f
interface
}


proc setlang {lang} {
global env plateforme baseHome
set env(LANG) $lang
set f [open [file join $baseHome reglages lang.conf] "w"]
puts $f $lang
close $f

::msgcat::mclocale $lang
::msgcat::mcload [file join [file dirname [info script]] msgs]
interface
}


